#include "StdAfx.h"
#include "GridCtrlEx.h"
#include "GridCellCheck.h"

CGridCtrlEx::CGridCtrlEx(void)
{
}

CGridCtrlEx::~CGridCtrlEx(void)
{
}

void CGridCtrlEx::PreSubclassWindow()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	CGridCtrl::PreSubclassWindow();

	// I don't want the WS_EX_CLIENTEDGE style
	ModifyStyleEx(WS_EX_CLIENTEDGE,0);

	// I prefer the WS_EX_STATICEDGE style instead
	//ModifyStyleEx(0,WS_EX_STATICEDGE);
}

void CGridCtrlEx::SetFocusCellEx(CCellID next)
{
	BOOL bChangeLine = FALSE;
	BOOL bHorzScrollAction = FALSE;
	BOOL bVertScrollAction = FALSE;

	if(next.col>=m_nCols)next.col=m_nCols-1;
	if(next.row>=m_nRows)next.row=m_nRows-1;

	if (next != m_idCurrentCell)
	{
		// While moving with the Cursorkeys the current ROW/CELL will get selected
		// OR Selection will get expanded when SHIFT is pressed
		// Cut n paste from OnLButtonDown - Franco Bez
		// Added check for NULL mouse mode - Chris Maunder.
		if (m_MouseMode == MOUSE_NOTHING)
		{
			m_PrevSelectedCellMap.RemoveAll();
			m_MouseMode = m_bListMode? MOUSE_SELECT_ROW : MOUSE_SELECT_CELLS;

			// Notify parent that selection is changing - Arthur Westerman/Scot Brennecke 
			OnSelecting(next);

			m_MouseMode = MOUSE_NOTHING;

		}

		SetFocusCell(next);

		if (!IsCellVisible(next))
		{

			if(next.row<m_idCurrentCell.row)
			{
				SendMessage(WM_VSCROLL, SB_LINEUP, 0);    
				bVertScrollAction = TRUE;
			}
			else
			{
				SendMessage(WM_VSCROLL, SB_LINEDOWN, 0);  
				bVertScrollAction = TRUE;
			}

			if(next.col<m_idCurrentCell.col)
			{
				SendMessage(WM_HSCROLL, SB_LINELEFT, 0);  
				bHorzScrollAction = TRUE;
			}
			else
			{
				SendMessage(WM_HSCROLL, SB_LINERIGHT, 0); 
				bHorzScrollAction = TRUE;
			}

			SimpleEnsureVisible(next); // Make sure cell is visible
		}
		EnsureVisible(next);
		if(next.row<m_nRows-1)
		{
			SendMessage(WM_VSCROLL, SB_LINEDOWN, 0);
			SendMessage(WM_VSCROLL, SB_LINEUP, 0);
		}
		else
		{
			SendMessage(WM_VSCROLL, SB_LINEUP, 0);
			SendMessage(WM_VSCROLL, SB_LINEDOWN, 0);
		}

		if(next.col<m_nCols-1)
		{
			SendMessage(WM_HSCROLL, SB_LINERIGHT, 0);
			SendMessage(WM_HSCROLL, SB_LINELEFT, 0);
		}
		else
		{
			SendMessage(WM_HSCROLL, SB_LINELEFT, 0);
			SendMessage(WM_HSCROLL, SB_LINERIGHT, 0);
		}

		if (bHorzScrollAction)
			SendMessage(WM_HSCROLL, SB_ENDSCROLL, 0);
		if (bVertScrollAction)
			SendMessage(WM_VSCROLL, SB_ENDSCROLL, 0);
	}
}

void CGridCtrlEx::SimpleEnsureVisible(int nRow, int nCol)
{
	if (!m_bAllowDraw)
		return;

	CRect rectWindow;

	// set the scroll to the approximate position of row (Nigel Page-Jones)
	int nPos = (int)((float)nRow / GetRowCount() * 1000);
	float fPos = (float)nPos / 1000;
	SCROLLINFO scrollInfo;
	GetScrollInfo(SB_VERT, &scrollInfo);
	scrollInfo.nPos = (int)(scrollInfo.nMax * fPos);
	SetScrollInfo(SB_VERT, &scrollInfo, FALSE);

	GetClientRect(rectWindow);

	// redraw cells    if necessary (Nigel Page-Jones)
	CCellID idTopLeft = GetTopleftNonFixedCell(FALSE);
	CCellID idNewTopLeft = GetTopleftNonFixedCell(TRUE);
	if (idNewTopLeft != idTopLeft)
	{
		rectWindow.top = GetFixedRowHeight();
		//InvalidateRect(rectWindow);
	}
}
