/////////////////////////////////////////////////////////////////////////////
//
// File    : MemDC.h
// Author  : Keith Rule (keithr@europa.com)
// Date    : 1997.xx.xx
// Purpose : Declaration of Memory Device Context
//
// Copyright(C) 1996-1997 Keith Rule
// All rights reserved.
// You may freely use or modify this code provided this
// Copyright is included in all derived versions.
//
/////////////////////////////////////////////////////////////////////////////
// Revision History:
//
// 1997.03.10 Fixed scrolling bug, Added print support.
// 1998.02.25 Fixed minor assertion bug.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __MEMDC_H__
#define __MEMDC_H__

/*/
#ifdef ST_USE_MEMDC
//*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// Pre-Class Declarations
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
// Class Declaration
//
/////////////////////////////////////////////////////////////////////////////
class CMyMemDC : public CDC
{
//===========================================================================
// Constructor & Destructor
public:
	CMyMemDC(CDC* pDC);						// sets up the memory DC
	virtual ~CMyMemDC();						// copies the contents of the mem DC to the original DC

//===========================================================================
// Attributes
protected:
	CDC*					m_pDC;			// Saves CDC passed in constructor
	//
	CBitmap					m_Bitmap;		// Offscreen bitmap
	CBitmap*				m_pOldBitmap;	// bitmap originally found in CMemDC
	//
	CRect					m_rect;			// Rectangle of Drawing area
	//
	BOOL					m_bMemDC;		// TRUE if CDC really is a Memory DC.

//===========================================================================
// Implementations
protected:

//===========================================================================
// Interfaces
public:
	CMyMemDC*					operator->()					{ return this; }	// Allow usage as a pointer
	operator CMyMemDC*()										{ return this; }	// Allow usage as a pointer

//===========================================================================
// Overrides
protected:

};

//{{AFX_INSERT_LOCATION}}

/*/
#endif // ST_USE_MEMDC
//*/

#endif // __MEMDC_H__