#include "stdafx.h"
#include "SubFunc.h"

int ConvertU16LE(BYTE * arFileData,UINT uLength,wchar_t* wszDest,UINT uDestLength,int nCodePage)
{
	int nCodeFlag=0; //0:nCodePage 1:16LE 2: 16BE 3:8
	//1ܰ BOM Ȯ

	int nOffset=0;

	if(uLength>=2&&arFileData[0]==0xFF&&arFileData[1]==0xFE)
	{
		nCodeFlag=1;
		nOffset=2;
	}
	else if(uLength>=2&&arFileData[0]==0xFE&&arFileData[1]==0xFF)
	{
		nCodeFlag=2;
		nOffset=2;
	}
	else if(uLength>=3&&arFileData[0]==0xEF&&arFileData[1]==0xBB&&arFileData[2]==0xBF)
	{
		nCodeFlag=3;
		nOffset=3;
		nCodePage=CP_UTF8;
	}
	int nSize=0;
	if(nCodeFlag==3||nCodeFlag==0)
	{
		nSize=MultiByteToWideChar(nCodePage,0,(LPCSTR)arFileData+nOffset,uLength-nOffset,wszDest,uDestLength);
		wszDest[nSize]=L'\0';
	}
	else
	{
		memcpy_s(wszDest,uDestLength,arFileData+nOffset,uLength-nOffset);
		nSize=(uLength-nOffset)/sizeof(WCHAR);
		wszDest[nSize]=L'\0';

		if(nCodeFlag==2)
		{
			UINT uSize=(UINT)nSize;
			for(UINT uIdx=0;uIdx<uSize;uIdx++)
			{
				wszDest[uIdx]=wszDest[uIdx]<<8|wszDest[uIdx]>>8;
			}
		}
	}

	return nSize;
}

bool TokenizeText(CString* strData,CStringArray * arDepo)
{
	bool bRet=true;

	int nBase=0;
	int nCurr=0;

	bool bFlag=true;
	while(bFlag)
	{
		nCurr=strData->Find(L"\r\n",nBase);

		if(nCurr<0)
		{
			bFlag=false;
			nCurr=strData->GetLength();
		}

		arDepo->Add(strData->Mid(nBase,nCurr-nBase));
		nBase=nCurr+2;
	}

	return true;
}

bool MergeText(CString* strData,CArray<CString*>* arDepo)
{
	bool bRet=true;

	if(strData==NULL)	return false;
	if(arDepo==NULL)	return false;

	strData->Empty();

	int nSize=arDepo->GetSize();

	for(int nIdx=0;nIdx<nSize;nIdx++)
	{
		CString * pstrChunk =arDepo->GetAt(nIdx);

		if(pstrChunk!=NULL)
		{
			strData->Append(*pstrChunk);
		}

		if(nIdx<nSize-1)
		{
			strData->Append(L"\r\n");
		}
	}

	return true;
}

bool isFileExists(LPCWSTR szFileName)
{
	//http://djkrok.tistory.com/4
	if (NULL == szFileName) {
		return (false);
	}

	DWORD attr = ::GetFileAttributes(szFileName);
	if (attr != 0xFFFFFFFFL) {
		return ((attr & FILE_ATTRIBUTE_DIRECTORY) == 0);
	} else {
		return (false);
	}
}

bool isDirectoryExists(LPCWSTR szPath)
{
	if (NULL == szPath) {
		return (false);
	}

	DWORD attr = ::GetFileAttributes(szPath);
	if (attr != 0xFFFFFFFFL) {
		return ((attr & FILE_ATTRIBUTE_DIRECTORY) != 0);
	} else {
		return (false);
	}
}